unit UGUI;       // vierte Version, mit Positionswahl ohne Einschrnkung 
{Die Klasse TSpielfeld beschreibt die graphische Benutzeroberflche.
Die eigentliche Spielsteuerung wird ber eine Instanz der Klasse
TSpielverwaltung realisiert.}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, UStecker, USteckfolge, USpielverwaltung,
  USteckerpanel;

type
  TSpielfeld = class(TForm)
    pnSteuerung: TPanel;
    lbFarbwahl: TLabel;
    pnFarbwahl: TPanel;
    btEingabe: TButton;
    btNeu: TButton;
    btEnde: TButton;
    pnSpielbrett: TPanel;
    lbEingabe: TLabel;
    lbBewertung: TLabel;
    lbErfolg: TLabel;
    lbLoesung: TLabel;
    btLoesung: TButton;
    procedure btEndeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Farbauswahl(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Positionswahl(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  private
  public
    Steckerpanel: array[1..13,1..2] of TSteckerpanel;
    Farbshape: array[1..6] of TShape;
  end;

var
  Spielfeld: TSpielfeld;
  Spielverwaltung: TSpielverwaltung;



implementation

{$R *.dfm}

procedure TSpielfeld.btEndeClick(Sender: TObject);
begin
  application.Terminate;
end;

procedure TSpielfeld.FormCreate(Sender: TObject);
var Spalte,Zeile,Stelle,X,Y: integer;
begin
  {Alle Steckerpanel erzeugen}
  for Zeile:=1 to 12 do
    for Spalte:=1 to 2 do
    begin
      X:=8+(Spalte-1)*98;
      Y:=24+(Zeile-1)*26;
      Steckerpanel[Zeile,Spalte]:=TSteckerpanel.create(Spielfeld.pnSpielbrett,X,Y,96,24);
      for Stelle:=1 to 4 do
        Steckerpanel[Zeile,Spalte].Kreis[Stelle].OnMouseDown:=Positionswahl;
    end;
    Steckerpanel[13,1]:=TSteckerpanel.create(Spielfeld.pnSpielbrett,8,360,96,24);
    {Panel fr Farbauswahl erzeugen}
    for Zeile:=1 to 6 do
    begin
      Farbshape[Zeile]:=TShape.Create(pnFarbwahl);
      with Farbshape[Zeile] do
      begin
        Shape:=stCircle;
        Left:=24;
        Top:=16+(Zeile-1)*32;
        Width:=20;
        Height:=20;
        Parent:=pnFarbwahl;
        case Zeile of
          1: Brush.Color:= clRed;
          2: Brush.Color:= clLime;
          3: Brush.Color:= clYellow;
          4: Brush.Color:= clBlue;
          5: Brush.Color:= clFuchsia;
          6: Brush.Color:= clAqua;
        end; {case}
        OnMouseDown:=Farbauswahl;
      end; {with}
    end; {for}
  {Spielverwaltung initialisieren}
  Spielverwaltung:=TSpielverwaltung.create;
end;

procedure TSpielfeld.Farbauswahl(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var Zeile:integer;
begin
  for Zeile:=1 to 6 do
    if Sender=Farbshape[Zeile] then
    begin  {vergrern und Koordinaten anpassen, AktuellerStecker setzen}
      with Farbshape[Zeile] do
      begin
        Left:=19;
        Top:=11+(Zeile-1)*32;
        Width:=30;
        Height:=30;
      end; {with}
      Spielverwaltung.AktuellerStecker.Farbe:=Farbshape[Zeile].Brush.Color;
    end
    else {alle anderen zurcksetzen auf normale Position und Gre}
      with Farbshape[Zeile] do
      begin
        Left:=24;
        Top:=16+(Zeile-1)*32;
        Width:=20;
        Height:=20;
      end; {with}
end;

procedure TSpielfeld.Positionswahl(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var Zeile,Stelle:integer;
begin
    for Zeile:=1 to 12 do
      for Stelle:=1 to 4 do
        if Sender=Steckerpanel[Zeile,1].Kreis[Stelle] then
        begin
          if Steckerpanel[Zeile,1].Kreis[Stelle].Brush.Color<>Spielverwaltung.AktuellerStecker.Farbe then
            Steckerpanel[Zeile,1].Kreis[Stelle].Brush.Color:=Spielverwaltung.AktuellerStecker.Farbe
          else
            Steckerpanel[Zeile,1].Kreis[Stelle].Brush.Color:=clGray;
        end; {if}
end;


end.
