unit USpielverwaltung;
{Die Klasse TSpielverwaltung dient der Steuerung des Spielablaufs.
Sie ist unabhngig von der Benutzeroberflche.}

interface

uses USteckerfolge, UStecker, Graphics;

type TSpielverwaltung=class
  private
  public
    AktuellerStecker:TStecker;
    Vorgabe: TSteckerfolge;
    Tipp: TSteckerfolge;
    Kopie: TSteckerfolge;
    Bewertung: TSteckerfolge;
    procedure initialisieren;
    procedure bewerten;
    constructor create;
end;



implementation

constructor TSpielverwaltung.create;
begin
  AktuellerStecker:=TStecker.Create;
  initialisieren;
end;

procedure TSpielverwaltung.initialisieren;
var Stelle, Farbe: integer;
begin
  Vorgabe:=TSteckerfolge.create;
  Tipp:=TSteckerfolge.create;
  Kopie:=TSteckerfolge.create;
  Bewertung:=TSteckerfolge.create;
  randomize;
  for Stelle:=1 to 4 do
  begin
    Farbe:=random(6);
    case Farbe of
      0: Vorgabe.Stecker[Stelle].Farbe:=clRed;
      1: Vorgabe.Stecker[Stelle].Farbe:=clLime;
      2: Vorgabe.Stecker[Stelle].Farbe:=clYellow;
      3: Vorgabe.Stecker[Stelle].Farbe:=clBlue;
      4: Vorgabe.Stecker[Stelle].Farbe:=clFuchsia;
      5: Vorgabe.Stecker[Stelle].Farbe:=clAqua;
    end;  {case}
  end;  {for}
end;

procedure TSpielverwaltung.bewerten;
var i,j,k:integer;
begin
  {Vorarbeiten}
  for i:=1 to 4 do
  begin
    Kopie.Stecker[i].Farbe:=Vorgabe.Stecker[i].Farbe;
    Bewertung.Stecker[i].Farbe:=clGray;
  end;
  i:=1;
  {nach richtiger Farbe an richtiger Position suchen}
  for j:=1 to 4 do
    if Tipp.Stecker[j].Farbe=Kopie.Stecker[j].Farbe then
    begin
      Bewertung.Stecker[i].Farbe:=clBlack;
      Tipp.Stecker[j].Farbe:=clGray;
      Kopie.Stecker[j].Farbe:=clGray;
      i:=i+1;
    end;
  {nach richtiger Farbe an falscher Position suchen}
  for j:=1 to 4 do
    if Tipp.Stecker[j].Farbe<>clGray then
      for k:=1 to 4 do
        if (Tipp.Stecker[j].Farbe<>clGray)
          and (Tipp.Stecker[j].Farbe=Kopie.Stecker[k].Farbe) then
        begin
          Bewertung.Stecker[i].Farbe:=clWhite;
          Tipp.Stecker[j].Farbe:=clGray;
          Kopie.Stecker[k].Farbe:=clGray;
          i:=i+1;
        end;
end;


end.
