unit UGUI;       // achte Version, mit Eingabebeschrnkung gegen Fehler
{Die Klasse TSpielfeld beschreibt die graphische Benutzeroberflche.
Die eigentliche Spielsteuerung wird ber eine Instanz der Klasse
TSpielverwaltung realisiert.}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, USpielverwaltung, USteckerpanel;

type
  TSpielfeld = class(TForm)
    pnSteuerung: TPanel;
    pnSpielbrett: TPanel;
    pnFarbwahl: TPanel;
    lbFarbwahl: TLabel;
    lbEingabe: TLabel;
    lbBewertung: TLabel;
    lbLoesung: TLabel;
    lbErfolg: TLabel;
    btEingabe: TButton;
    btNeu: TButton;
    btLoesung: TButton;
    btEnde: TButton;
    procedure btEndeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Farbauswahl(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Positionswahl(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btEingabeClick(Sender: TObject);
    procedure btNeuClick(Sender: TObject);
    procedure btLoesungClick(Sender: TObject);
  private
  public
    Steckerpanel: array[1..13,1..2] of TSteckerpanel;
    Farbkreis: array[1..6] of TShape;
  end;

var
  Spielfeld: TSpielfeld;
  Spielverwaltung: TSpielverwaltung;


implementation

{$R *.dfm}

procedure TSpielfeld.btEndeClick(Sender: TObject);
begin
  application.Terminate;
end;

procedure TSpielfeld.FormCreate(Sender: TObject);
var Zeile,Spalte,Stelle,X,Y: integer;
begin
  {Alle Steckerpanels erzeugen}
  for Zeile:=1 to 12 do
    for Spalte:=1 to 2 do
    begin
      X:=8+(Spalte-1)*98;
      Y:=24+(Zeile-1)*26;
      Steckerpanel[Zeile,Spalte]:=TSteckerpanel.create(pnSpielbrett,X,Y,96,24);
      for Stelle:=1 to 4 do
        Steckerpanel[Zeile,Spalte].Kreis[Stelle].OnMouseDown:=Positionswahl;
    end;
  Steckerpanel[13,1]:=TSteckerpanel.create(pnSpielbrett,8,360,96,24);
  {Panel fr Farbauswahl erzeugen}
  for Zeile:=1 to 6 do
  begin
    Farbkreis[Zeile]:=TShape.Create(pnFarbwahl);
    with Farbkreis[Zeile] do
    begin
      Shape:=stCircle;
      Left:=24;
      Top:=16+(Zeile-1)*32;
      Width:=20;
      Height:=20;
      case Zeile of
        1: Brush.Color:=clRed;
        2: Brush.Color:=clLime;
        3: Brush.Color:=clYellow;
        4: Brush.Color:=clBlue;
        5: Brush.Color:=clFuchsia;
        6: Brush.Color:=clAqua;
      end; {case}
      Parent:=pnFarbwahl;
      OnMouseDown:=Farbauswahl;
    end; {with}
  end; {for}
  {Spielverwaltung initialisieren}
  Spielverwaltung:=TSpielverwaltung.create;
  Steckerpanel[Spielverwaltung.Runde,1].Enabled:=true;
  btEingabe.Enabled:=false;
  {nur zum Testen
  for Stelle:=1 to 4 do
    Steckerpanel[13,1].zeichneKreis(Spielverwaltung.Vorgabe.Stecker[Stelle].Farbe,Stelle); }
end;

procedure TSpielfeld.Farbauswahl(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var Zeile:integer;
begin
  for Zeile:=1 to 6 do
    if Sender=Farbkreis[Zeile] then
    begin  {vergrern und Koordinaten anpassen, AktuellerStecker setzen}
      with Farbkreis[Zeile] do
      begin
        Left:=19;
        Top:=11+(Zeile-1)*32;
        Width:=30;
        Height:=30;
      end; {with}
      Spielverwaltung.AktuellerStecker.Farbe:=Farbkreis[Zeile].Brush.Color;
    end {if}
    else {alle anderen zurcksetzen auf normale Position und Gre}
      with Farbkreis[Zeile] do
      begin
        Left:=24;
        Top:=16+(Zeile-1)*32;
        Width:=20;
        Height:=20;
      end; {with}
end;

procedure TSpielfeld.Positionswahl(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var Zeile,Stelle, Summe:integer;
    AktuelleFarbe:TColor;
begin
  AktuelleFarbe:=Spielverwaltung.AktuellerStecker.Farbe;
  if Button=mbLeft then
    for Zeile:=1 to 12 do
      for Stelle:=1 to 4 do
        if Sender=Steckerpanel[Zeile,1].Kreis[Stelle] then
          if Steckerpanel[Zeile,1].Kreis[Stelle].Brush.Color<>AktuelleFarbe then
            Steckerpanel[Zeile,1].zeichneKreis(AktuelleFarbe,Stelle)
          else
            Steckerpanel[Zeile,1].zeichneKreis(clSilver,Stelle);
  Summe:=0;
  for Stelle:=1 to 4 do
    if Steckerpanel[Spielverwaltung.Runde,1].Kreis[Stelle].Brush.Color<>clSilver then
      Summe:=Summe+1;
  btEingabe.Enabled:=Summe=4;
end;


procedure TSpielfeld.btEingabeClick(Sender: TObject);
var Stelle:integer;
begin
  {Tipp speichern}
  for Stelle:=1 to 4 do
    Spielverwaltung.Tipp.Stecker[Stelle].Farbe:=Steckerpanel[Spielverwaltung.Runde,1].Kreis[Stelle].Brush.Color;
  {Bewertung aufrufen}
  Spielverwaltung.bewerten;
  {Bewertung anzeigen}
  for Stelle:=1 to 4 do                   
    Steckerpanel[Spielverwaltung.Runde,2].zeichneKreis(Spielverwaltung.Bewertung.Stecker[Stelle].Farbe,Stelle);
  Steckerpanel[Spielverwaltung.Runde,1].Enabled:=false;
  Spielverwaltung.Runde:=Spielverwaltung.Runde+1;
  {Ggf. Lsung und Erfolgsmeldung anzeigen}
  if (Spielverwaltung.Runde>12) or (Spielverwaltung.geloest) then
    btLoesungClick(self)
  else
    Steckerpanel[Spielverwaltung.Runde,1].Enabled:=true;
  btEingabe.Enabled:=false;
  Spielfeld.ActiveControl:=pnSteuerung;
end;

procedure TSpielfeld.btNeuClick(Sender: TObject);
var Zeile,Spalte,Stelle:integer;
begin
  Spielverwaltung.initialisieren;
  for Zeile:=1 to 12 do
    for Spalte:=1 to 2 do
      for Stelle:=1 to 4 do
        Steckerpanel[Zeile,Spalte].zeichneKreis(clSilver,Stelle);
  for Stelle:=1 to 4 do
    Steckerpanel[13,1].zeichneKreis(clSilver,Stelle);
  lbLoesung.Caption:='';
  lbErfolg.Caption:='';
  btEingabe.Enabled:=false;
  Steckerpanel[Spielverwaltung.Runde,1].Enabled:=true;
  for Zeile:=2 to 12 do
    Steckerpanel[Zeile,1].Enabled:=false;
  {nur zum Testen
  for Stelle:=1 to 4 do
    Steckerpanel[13,1].zeichneKreis(Spielverwaltung.Vorgabe.Stecker[Stelle].Farbe,Stelle); }
  Spielfeld.ActiveControl:=pnSteuerung;
end;

procedure TSpielfeld.btLoesungClick(Sender: TObject);
var Stelle:integer;
begin
  lbLoesung.Caption:='Lsung:';
  for Stelle:=1 to 4 do
    Steckerpanel[13,1].Kreis[Stelle].Brush.Color:=Spielverwaltung.Vorgabe.Stecker[Stelle].Farbe;
  if Spielverwaltung.geloest then
    lbErfolg.Caption:='... erraten im '+inttostr(Spielverwaltung.Runde-1)+'. Versuch.'
  else
    lbErfolg.Caption:='... nicht erraten!';
  Spielfeld.ActiveControl:=pnSteuerung;
end;

end.
